#include <iostream>

#include "memetype.h"
#include "memearray.h"
#include "meme.h"

class ArrayPrimitive : public MemePrimitive {
	private:
		MemeArray *deref(const Value& a);
	public:
		// these are not abstract, they all throw
		// errors if called on an object that does
		// not implement
		ArrayPrimitive();
		~ArrayPrimitive();

		virtual Value ini(const Value& x);

		virtual Value str(const Value& a);
		virtual Value num(const Value& a);
		
		virtual Value len(const Value& a);
		virtual Value idx(const Value& a, const Value& i);

		virtual Value ins(const Value& a, const Value& b);
		virtual Value cat(const Value& a, const Value& b);
};

MemePrimitive *getArrayPrimitive(void)
{
	return new ArrayPrimitive();
}


MemeArray *ArrayPrimitive::deref(const Value& a) {
	return (MemeArray *)(a.ref_.target());
}

ArrayPrimitive::ArrayPrimitive()
{
}

ArrayPrimitive::~ArrayPrimitive()
{
}

Value ArrayPrimitive::ini(const Value& x)
{
	return x;
}

Value ArrayPrimitive::str(const Value& a)
{
	return deref(a)->toString();
}

Value ArrayPrimitive::len(const Value& a)
{
	return (int)deref(a)->count();
}

Value ArrayPrimitive::num(const Value& a)
{
	return (int)deref(a)->count();
}

Value ArrayPrimitive::idx(const Value& a, const Value& i)
{
	MemeArray *arr = deref(a);
	// return a ref to the array index
	MemeRef vref( &( arr->idx( i.toInt() ) ) );
	return Value( valueRef, vref );
}

Value ArrayPrimitive::ins(const Value& a, const Value& i)
{
	MemeArray *arr = deref(a);
	arr->unshift( i );
	return i;
}

Value ArrayPrimitive::cat(const Value& a, const Value& i)
{
	MemeArray *arr = deref(a);
	arr->push( i );
	return i;
}

