

#include "memetype.h"
#include "meme.h"

class BoolPrimitive : public MemePrimitive {
	public:
		// these are not abstract, they all throw
		// errors if called on an object that does
		// not implement
		BoolPrimitive();
		~BoolPrimitive();

		// NOTE: this should have variable arguments
		virtual Value ini(const Value& x);

		virtual Value neg(const Value& x);

		virtual Value cmp(const Value& a, const Value& b);

		virtual Value str(const Value& a);
		virtual Value num(const Value& a);
		
};

MemePrimitive *getBoolPrimitive(void)
{
	return new BoolPrimitive();
}

// these are not abstract, they all throw
// errors if called on an object that does
// not implement
BoolPrimitive::BoolPrimitive()
{
}

BoolPrimitive::~BoolPrimitive()
{
}


// NOTE: this should have variable arguments
Value BoolPrimitive::ini(const Value& x)
{
	return x;
}


Value BoolPrimitive::neg(const Value& x)
{
	return Value( ! x.b );
}

Value BoolPrimitive::cmp(const Value& a, const Value& b)
{
	return Value( a.b - b.toBool() );
}

Value BoolPrimitive::str(const Value& a)
{
	if( a.b )
		return Value(valueStr, MemeString::newString("true") );
	else
		return Value(valueStr, MemeString::newString("false") );
}

Value BoolPrimitive::num(const Value& a)
{
	return a.b ? Value(1) : Value(0);
}

