/*
 * builtin.cpp
 *
 *  Created on: Mar 1, 2009
 *      Author: ranton
 */

using namespace std;

#include "meme.h"
#include "memetype.h"
#include "memeutil.h"

void RegisterCppFunc(MemeScope& scope, const char *name, std::string paramNames, MemeCppProc proc)
{
    vector<string> fields;
    SplitString(paramNames, fields);

    // create string of param name nodes for fields
    nodeType *params = NULL;
    vector<string>::iterator it;
    for( it = fields.begin(); it != fields.end(); it++ )
    {
    	params = chainArg( params, param(storeString(it->c_str())));
    }
    nodeType *p = makeFunctionNode(name, params);

	// assign function into global symbols
	MemeFunc *func= new MemeCppFunc( &scope, p, proc );
	Value fref( valueFunc, MemeRef( func ) );
	scope.define( p->func.name, fref );

}


void RegisterConstant(MemeScope& scope, const char *name, const Value& v)
{
	scope.define(name, v );
}
