/*
 * console.cpp
 *
 *  Created on: Mar 1, 2009
 *      Author: ranton
 */

#include "meme.h"
#include "memetype.h"

#include <iostream>
#include <cstdio>

using namespace std;

static Value bi_readline( MemeScope& scope )
{
	// read in a line of text and return it as a string.
	enum { kMaxLineLen = 1024 };

	char line[kMaxLineLen+1];
	line[0] = 0;
	cin.getline (line,kMaxLineLen);
	// NOTE: handling exceptions would be nice.

	if( cin.eof() && cin.gcount() == 0 )
		return Value();

	return Value( valueStr, MemeString::newString( line ) );
}

static Value bi_writeline( MemeScope& scope )
{
	// write out whatever the argument "s" is and a newline
	Value *v = scope.lookup("s");
	if( v )
	{
		v->println();
		return *v;
	}
	else
	{
		error("parameter missing from scope");
		return Value();
	}
}

static Value bi_writevalue( MemeScope& scope )
{
	// write out whatever the argument "s" is
	Value *v = scope.lookup("s");
	if( v )
	{
		v->print();
		return *v;
	}
	else
	{
		error("parameter missing from scope");
		return Value();
	}
}

void RegisterConsole(MemeScope& scope)
{
	RegisterCppFunc(scope, "readline", "", bi_readline );
	RegisterCppFunc(scope, "writeline", "s", bi_writeline );
	RegisterCppFunc(scope, "writevalue", "s", bi_writevalue );
}
