/*
 * function.cpp
 *
 *  Created on: Mar 10, 2009
 *      Author: ranton
 */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>


#include "memetype.h"
#include "meme.h"

class FuncPrimitive : public MemePrimitive {
	public:
		// these are not abstract, they all throw
		// errors if called on an object that does
		// not implement
		FuncPrimitive();
		~FuncPrimitive();

		// NOTE: this should have variable arguments
		virtual Value ini(const Value& x);

		virtual Value cmp(const Value& a, const Value& b);

		virtual Value str(const Value& a);

};

MemePrimitive *getFuncPrimitive(void)
{
	return new FuncPrimitive();
}

// these are not abstract, they all throw
// errors if called on an object that does
// not implement
FuncPrimitive::FuncPrimitive()
{
}

FuncPrimitive::~FuncPrimitive()
{
}


// NOTE: this should have variable arguments
Value FuncPrimitive::ini(const Value& x)
{
	return x;
}


Value FuncPrimitive::cmp(const Value& a, const Value& b)
{
	if (a.type == valueFunc && b.type == valueFunc && a.ref_.target() == b.ref_.target() )
		return 0;
	else
		return -1;
}

Value FuncPrimitive::str(const Value& a)
{
	return Value(valueStr, MemeString::newString( "FUNCTION" ) );
}

