#ifndef __MEMEARRAY__
#define __MEMEARRAY__

#include "memetype.h"
#include <list>

class MemeArray : public MemeCollect {
private:
	std::list<Value> elements_;
	static Value sOutOfBounds_; // returned for ref's when out of bounds
public:	
	MemeArray(void);
	MemeArray(unsigned size);


	Value& operator[] (int i);
	Value& idx(int i);

	size_t count( void );

	void insert( int at, const Value& val );

	void push( const Value& val );
	void unshift( const Value& val );

	Value pop(void); // remove and return from back
	Value shift(void); // remove and return from front

	Value& front(void);
	Value& back(void);

	// resize
	void resize( size_t sz );
	
	// erase
	void erase( size_t idx, size_t count=1 );

	// convert to string
	Value toString(void);

	// creates a new ref counted array
	static MemeRef newArray(void);

	static bool test(void);
};

#endif

