/*
 * memehash.h
 *
 *  Created on: Mar 8, 2009
 *      Author: richardanton
 */

#ifndef MEMEHASH_H_
#define MEMEHASH_H_

#include "memetype.h"
#include "memearray.h"
#include <map>
#include <string>


typedef std::pair<std::string,Value> MemeHashEntry;

class MemeHash : public MemeCollect {
private:
	std::map<std::string,Value> map_;

	std::string hkey(const Value& val);
public:
	MemeHash();
	virtual ~MemeHash();

	Value& operator[] (const Value& key);
	Value& idx(const Value& key);

	size_t count( void );

	void insert( const Value& key, const Value& val );
	Value erase( const Value& key );
	bool exists( const Value& key );

	// convert to string
	Value toString(void);

	// creates a new ref counted hash
	static MemeRef newHash(void);

	// return an array of all the keys
	Value keys(void);

	// return an array of all the values
	Value values(void);

	static bool test(void);
};

#endif /* MEMEHASH_H_ */
