/*
 * memeutil.cpp
 *
 *  Created on: Mar 1, 2009
 *      Author: ranton
 */

#include "memeutil.h"

using namespace std;

void SplitString(const std::string & paramNames, std::vector<std::string> & fields)
{
	fields.clear();
    size_t pos = 0, last = 0;
    while((pos = paramNames.find(',', last)) != string::npos){
        fields.push_back(paramNames.substr(last, pos - last));
        last = pos+1;
    }
    if(last < paramNames.size())
        fields.push_back(paramNames.substr(last));
}

bool TestSplit(void)
{
	vector<string> fields;
	SplitString( "first,second,third", fields);
	if( fields.size() != 3 )
		return false;
	if( fields[0] != string("first"))
		return false;
	if( fields[1] != string("second"))
		return false;
	if( fields[2] != string("third"))
		return false;
	return true;
}

Value getVar( MemeScope& scope, const char *name)
{
	Value *v = scope.lookup( name );
	if( v )
		return *v;
	else
		return Value();
}


Value getVarValue( MemeScope& scope, const char *name )
{
	return getVar(scope,name).value().value(); // strangely necessary, mb I will understand why twice
}
