#include "meme.h"
#include "memebase.h"
#include "memearray.h"
#include "memehash.h"
#include "memeutil.h"

#include <iostream>
using namespace std;

bool runTest(const char *name, bool (*testFunc)(void))
{
	cout << name;
	bool status = testFunc();
	cout << (status ?  " -> PASSED\n" : " -> FAILED\n" );
	return status;
}

// test harness
int main(int argc, const char **argv, char **envp)
{
	setup(argc,argv,envp);

	bool good = true;
	good = runTest("GC", MemeReaper::test) && good;
	good = runTest("Array", MemeArray::test) && good;
	good = runTest("Split", TestSplit) && good;
	good = runTest("Hash", MemeHash::test) && good;

	return good ? 0 : 1;
}

